<template>
    <div class="container-fluid bg-white">
        <div class="row p-4">
            <div class="col-12 text-right">
                <button
                    class="btn btn-success"
                    @click="$modal.show('store-invoice', { view: 'create' })"
                >
                    Create New Invoice
                </button>
            </div>
        </div>

        <div class="bg-white overflow-wrapper">
            <table class="table">
                <thead>
                    <tr>
                        <th style="min-width: 80px">
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="invoices = orderTable(invoices, 'id')"
                            />
                            # ID
                        </th>
                        <th style="min-width: 150px">
                            <input
                                v-model="pattern"
                                type="text"
                                class="form-control mb-2"
                                placeholder="..."
                                @input="search()"
                            />
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    invoices = orderTable(invoices, 'number')
                                "
                            />
                            Number
                        </th>
                        <th style="min-width: 200px">
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="invoices = orderTable(invoices, 'bank')"
                            />
                            Bank
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="invoices = orderTable(invoices, 'date')"
                            />
                            Date
                        </th>
                        <th style="min-width: 130px">
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    invoices = orderTable(invoices, 'customer')
                                "
                            />
                            Customer
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    invoices = orderTable(invoices, 'packages')
                                "
                            />
                            Packages
                        </th>
                        <th style="min-width: 130px">
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    invoices = orderTable(
                                        invoices,
                                        'created_at'
                                    )
                                "
                            />
                            Created At
                        </th>
                        <th style="min-width: 130px">
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    invoices = orderTable(
                                        invoices,
                                        'updated_at'
                                    )
                                "
                            />
                            Updated At
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(item, index) in invoices" :key="index">
                        <td>{{ item.id }}</td>
                        <td>
                            <span
                                class="link-button"
                                @click="
                                    $modal.show('store-invoice', {
                                        view: 'edit',
                                        invoice: item,
                                    })
                                "
                            >
                                {{ item.number }}
                            </span>
                        </td>
                        <td>
                            {{ item.bank.name }}
                        </td>
                        <td>{{ item.date | moment("DD.MM.YYYY") }}</td>
                        <td>
                            <span>{{ item.customer.name }}</span>
                        </td>
                        <td>
                            <span
                                v-for="product in item.packages"
                                class="badge badge-pill badge-secondary p-2 mx-1"
                            >
                                {{ product.name }} -
                                {{ product.pivot.quantity }}
                            </span>
                        </td>
                        <td>
                            {{ item.created_at | moment("DD.MM.YYYY HH:MM") }}
                        </td>
                        <td>
                            {{ item.updated_at | moment("DD.MM.YYYY HH:MM") }}
                        </td>
                    </tr>
                </tbody>
                <tbody v-if="!invoices.length">
                    <tr>
                        <td colspan="999999">
                            <div class="alert alert-secondary" role="alert">
                                Invoice list is empty !
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>

            <div v-if="isLoading" class="loader" />
        </div>

        <store-invoice :invoices="invoices" @update="updateArray" />

        <preview />
    </div>
</template>

<script>
import { loadMoreMixin } from "../../mixin/loadMoreMixin";

export default {
    filters: {
        digit(value) {
            if (!value) return "";
            var parts = value.toString().split(".");
            parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ".");
            parts[0] += ",00";
            return parts.join(",");
        },
    },

    mixins: [loadMoreMixin],

    data() {
        return {
            invoices: [],
            pattern: "",
        };
    },
    mounted() {
        axios
            .post("/api/invoices/list", {
                with: ["bank", "customer", "packages", "notes"],
                take: this.take,
                skip: this.skip,
                orderBy: {
                    name: "id",
                    value: "desc",
                },
            })
            .then((response) => {
                this.invoices = response.data;
            });
    },
    methods: {
        updateArray(event) {
            location.reload();
        },
        search() {
            axios
                .post("/api/invoices/list", {
                    pattern: this.pattern,
                    getAll: true,
                    orderBy: {
                        name: "id",
                        value: "desc",
                    },
                })
                .then((response) => {
                    this.invoices = response.data;
                });
        },

        downloadExcel() {
            axios({
                url: "/export/invoices",
                method: "POST",
                responseType: "blob",
            }).then((response) => {
                const url = window.URL.createObjectURL(
                    new Blob([response.data])
                );

                const link = document.createElement("a");
                link.href = url;
                link.setAttribute("download", "invoices.xlsx");
                document.body.appendChild(link);
                link.click();
            });
        },

        loadMore() {
            // Show loading more
            this.isLoading = true;

            // Get total products
            let length = this.invoices.length;

            if (this.load && length >= 50) {
                this.timeout = setTimeout(() => {
                    this.skip += 50;

                    axios
                        .post("/api/invoices/list", {
                            with: ["bank", "customer", "packages", "notes"],
                            take: this.take,
                            skip: this.skip,
                            orderBy: {
                                name: "id",
                                value: "desc",
                            },
                        })
                        .then((response) => {
                            // Merge arrays
                            this.invoices = this.invoices.concat(response.data);
                            // Hide loading more
                            this.isLoading = false;
                            // disable new calls if there arent any new companies
                            length == this.invoices.length
                                ? (this.load = false)
                                : (this.load = true);
                        });
                }, 500);
            } else {
                // Hide loading more
                this.isLoading = false;
            }
        },
    },
};
</script>
